## shards 0.17.3

=== Makefile ===
.POSIX:

release ?=      ## Compile in release mode
debug ?=        ## Add symbolic debug info
static ?=       ## Enable static linking

CRYSTAL ?= crystal
SHARDS ?= shards
override FLAGS += $(if $(release),--release )$(if $(debug),-d )$(if $(static),--static )

SHARDS_SOURCES = $(shell find src -name '*.cr')
MOLINILLO_SOURCES = $(shell find lib/molinillo -name '*.cr' 2> /dev/null)
SOURCES = $(SHARDS_SOURCES) $(MOLINILLO_SOURCES)
TEMPLATES = src/templates/*.ecr

SHARDS_CONFIG_BUILD_COMMIT := $(shell git rev-parse --short HEAD 2> /dev/null)
SHARDS_VERSION := $(shell cat VERSION)
SOURCE_DATE_EPOCH := $(shell (git show -s --format=%ct HEAD || stat -c "%Y" Makefile || stat -f "%m" Makefile) 2> /dev/null)
EXPORTS := SHARDS_CONFIG_BUILD_COMMIT="$(SHARDS_CONFIG_BUILD_COMMIT)" SOURCE_DATE_EPOCH="$(SOURCE_DATE_EPOCH)"
DESTDIR ?=
PREFIX ?= /usr/local
BINDIR ?= $(DESTDIR)$(PREFIX)/bin
MANDIR ?= $(DESTDIR)$(PREFIX)/share/man
INSTALL ?= /usr/bin/install

MOLINILLO_VERSION = $(shell $(CRYSTAL) eval 'require "yaml"; puts YAML.parse(File.read("shard.lock"))["shards"]["molinillo"]["version"]')
MOLINILLO_URL = "https://github.com/crystal-lang/crystal-molinillo/archive/v$(MOLINILLO_VERSION).tar.gz"

all: build

include docs.mk

build: phony bin/shards

clean: phony clean_docs
	rm -f bin/shards

bin/shards: $(SOURCES) $(TEMPLATES) lib
	@mkdir -p bin
	$(EXPORTS) $(CRYSTAL) build $(FLAGS) src/shards.cr -o bin/shards

install: bin/shards man/shards.1.gz man/shard.yml.5.gz phony
	$(INSTALL) -m 0755 -d "$(BINDIR)" "$(MANDIR)/man1" "$(MANDIR)/man5"
	$(INSTALL) -m 0755 bin/shards "$(BINDIR)"
	$(INSTALL) -m 0644 man/shards.1.gz "$(MANDIR)/man1"
	$(INSTALL) -m 0644 man/shard.yml.5.gz "$(MANDIR)/man5"

uninstall: phony
	rm -f "$(BINDIR)/shards"
	rm -f "$(MANDIR)/man1/shards.1.gz"
	rm -f "$(MANDIR)/man5/shard.yml.5.gz"

test: test_unit test_integration

test_unit: phony lib
	$(CRYSTAL) spec ./spec/unit/

test_integration: bin/shards phony
	$(CRYSTAL) spec ./spec/integration/

lib: shard.lock
	mkdir -p lib/molinillo
	$(SHARDS) install || (curl -L $(MOLINILLO_URL) | tar -xzf - -C lib/molinillo --strip-components=1)

shard.lock: shard.yml
	[ $(SHARDS) = false ] || $(SHARDS) update

man/%.gz: man/%
	gzip -c -9 $< > $@

phony:

=== debian/changelog ===
shards (0.17.3-2build1) noble; urgency=medium

  * No-change rebuild for libevent t64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Apr 2024 10:14:57 +0200

shards (0.17.3-2) unstable; urgency=medium

  * Source upload.

 -- David Suárez <deiv@debian.org>  Tue, 15 Aug 2023 22:08:29 +0200

shards (0.17.3-1) unstable; urgency=medium

  * Initial release. (Closes: #1043375)

 -- David Suárez <deiv@debian.org>  Mon, 14 Aug 2023 20:29:48 +0200

=== debian/control ===
Source: shards
Section: devel
Priority: optional
Maintainer: David Suárez <deiv@debian.org>
Rules-Requires-Root: no
Build-Depends: asciidoctor,
               crystal,
               debhelper-compat (= 13),
               fossil,
               git,
               libyaml-dev,
               mercurial
Standards-Version: 4.6.2
Homepage: https://crystal-lang.org/
Vcs-Git: https://salsa.debian.org/deiv/shards.git
Vcs-Browser: https://salsa.debian.org/deiv/shards

Package: shards
Architecture: amd64
Depends: crystal, ${misc:Depends}, ${shlibs:Depends}
Recommends: git
Suggests: fossil, mercurial
Description: dependency manager for the Crystal language
 Shards is the dependency manager for the Crystal programming language.
 .
 It manages dependencies for Crystal projects and libraries with
 reproducible installs across computers and systems.

## shards 0.19.0

=== debian/changelog ===
shards (0.19.0-1) unstable; urgency=medium

  * New upstream version.

 -- David Suárez <deiv@debian.org>  Fri, 20 Dec 2024 17:54:29 +0100

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

make_options += release=1
molinillo_lib = molinillo

%:
	dh $@

override_dh_auto_build:
	mkdir lib
	cd lib && ln -s ../crystal-molinillo $(molinillo_lib)
	dh_auto_build -- $(make_options)

override_dh_auto_install: DESTDIR=$(CURDIR)/debian/tmp
override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir $(CURDIR)/tmp
	# don't run in parallel, the temporal created dirs clashes between them
	HOME=$(CURDIR)/tmp make $(make_options) test_unit
	HOME=$(CURDIR)/tmp make $(make_options) test_integration
endif

override_dh_clean:
	dh_clean
	rm -f man/*.gz
	rm -Rf spec/.repositories/
	rm -Rf tmp/*
	rm -Rf lib

=== debian/watch ===
version=4

opts=\
dversionmangle=auto,\
filenamemangle=s/.+\/v(\d\S+)\.tar\.gz/shards-$1\.tar\.gz/ \
  https://github.com/crystal-lang/shards/tags .*/v(\d\S+)\.tar\.gz debian

opts="component=crystal-molinillo,\
dversionmangle=auto,\
filenamemangle=s/.+\/v(\d\S+)\.tar\.gz/crystal-molinillo-$1\.tar\.gz/" \
  https://github.com/crystal-lang/crystal-molinillo/tags .*/v(\d\S+)\.tar\.gz ignore
